#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <tf2_stocks>
#include <dhooks>
#include <tf2utils>
#include <tf_custom_attributes>
#include <tf_cattr_ball_impact_effect>
#include <viewmodel_override>

#define PLUGIN_VERSION "0.1.0"

public Plugin myinfo = {
    name = "[TF2] Tropic Crisis Custom Attributes",
    author = "Mathx",
    description = "Custom attributes used by weapons from Tropic Crisis",
    version = PLUGIN_VERSION,
    url = "https://tropic-crisis.tf2maps.net"
};

#include "tropic_crisis_attributes/rocket.sp"
#include "tropic_crisis_attributes/ball.sp"
#include "tropic_crisis_attributes/outline.sp"
#include "tropic_crisis_attributes/stick-bomb.sp"
#include "tropic_crisis_attributes/uber-sound.sp"
#include "tropic_crisis_attributes/model.sp"

public void OnPluginStart() {
    UberSound_Init();
    Model_Init();
    StickBomb_Init();

    for(int i = 1; i <= MaxClients; i++) {
        if(IsClientInGame(i)) {
            OnClientPutInServer(i);
        }
    }
}

public void OnAllPluginsLoaded() {
    Outline_Init();
}

public void OnMapStart() {
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_ball.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_ball.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_ball.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_ball.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_ball.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_ball.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_bat.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_bat.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_bat.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_bat.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_bat.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_bat.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_molina/c_molina.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_molina/c_molina.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_molina/c_molina.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_molina/c_molina.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_molina/c_molina.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_molina/c_molina.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_retroactor/c_retroactor.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_retroactor/c_retroactor.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_retroactor/c_retroactor.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_retroactor/c_retroactor.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_retroactor/c_retroactor.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_retroactor/c_retroactor.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_smoking_snake/c_smoking_snake.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_smoking_snake/c_smoking_snake.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_smoking_snake/c_smoking_snake.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_smoking_snake/c_smoking_snake.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_smoking_snake/c_smoking_snake.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_smoking_snake/c_smoking_snake.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tecnine/c_tecNine.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tecnine/c_tecNine.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tecnine/c_tecnine.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tecnine/c_tecNine.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tecnine/c_tecNine.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tecnine/c_tecnine.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle_exploded.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle_exploded.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle_exploded.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle_exploded.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle_exploded.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle_exploded.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/c_tropic_launcher.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/c_tropic_launcher.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/c_tropic_launcher.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/c_tropic_launcher.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/c_tropic_launcher.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/c_tropic_launcher.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/w_cuban_rocket.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/w_cuban_rocket.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/w_cuban_rocket.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/w_cuban_rocket.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/w_cuban_rocket.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_launcher/w_cuban_rocket.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_revolver/c_tropic_revolver.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_revolver/c_tropic_revolver.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_revolver/c_tropic_revolver.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_revolver/c_tropic_revolver.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_revolver/c_tropic_revolver.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/c_models/c_tropic_revolver/c_tropic_revolver.vvd");

    AddFileToDownloadsTable("models/weapons/tropic_crisis/retroactor/medic.dx80.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/retroactor/medic.dx90.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/retroactor/medic.mdl");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/retroactor/medic.phy");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/retroactor/medic.sw.vtx");
    AddFileToDownloadsTable("models/weapons/tropic_crisis/retroactor/medic.vvd");

    AddFileToDownloadsTable("materials/models/tropic_crisis/weapons/c_items/c_artisan_melee/c_artisan_ball_blue.vmt");
    AddFileToDownloadsTable("materials/models/tropic_crisis/weapons/c_items/c_artisan_melee/c_artisan_ball_blue.vtf");
    AddFileToDownloadsTable("materials/models/tropic_crisis/weapons/c_items/c_artisan_melee/c_artisan_ball.vmt");
    AddFileToDownloadsTable("materials/models/tropic_crisis/weapons/c_items/c_artisan_melee/c_artisan_ball.vtf");
    AddFileToDownloadsTable("materials/models/tropic_crisis/weapons/c_items/c_artisan_melee/c_artisan_bat_blue.vmt");
    AddFileToDownloadsTable("materials/models/tropic_crisis/weapons/c_items/c_artisan_melee/c_artisan_bat_blue.vtf");
    AddFileToDownloadsTable("materials/models/tropic_crisis/weapons/c_items/c_artisan_melee/c_artisan_bat.vmt");
    AddFileToDownloadsTable("materials/models/tropic_crisis/weapons/c_items/c_artisan_melee/c_artisan_bat.vtf");

    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_molina/c_molina.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_molina/c_molina.vtf");

    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor_backpack.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor_backpack.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor_fans.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor_fans.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor_screen_illum.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor_screen_illum.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor_screen.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor_screen.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_retroactor/c_retroactor.vtf");

    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_smoking_snake/c_smoking_snake.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_smoking_snake/c_smoking_snake.vtf");

    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tecnine/c_tecnine.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tecnine/c_tecnine.vtf");

    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle_label2.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle_labels.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle_liquid_blue.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle_liquid_blue.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle_liquid.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle_liquid.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle_phong.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle_top.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_bottle/c_tropic_bottle.vtf");

    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_launcher/c_cuban_rocket_blue.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_launcher/c_cuban_rocket_blue.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_launcher/c_cuban_rocket.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_launcher/c_cuban_rocket.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_launcher/c_tropic_launcher.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_launcher/c_tropic_launcher.vtf");

    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_revolver/c_tropic_revolver_blue.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_revolver/c_tropic_revolver_blue.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_revolver/c_tropic_revolver_exp.vtf");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_revolver/c_tropic_revolver.vmt");
    AddFileToDownloadsTable("materials/models/workshop/weapons/c_models/c_tropic_revolver/c_tropic_revolver.vtf");

    AddFileToDownloadsTable("sound/tropic_crisis/weapons/retroactor/uber_ready.wav");
    AddFileToDownloadsTable("sound/tropic_crisis/weapons/retroactor/uber1.mp3");
    AddFileToDownloadsTable("sound/tropic_crisis/weapons/retroactor/uber2.mp3");

    PrecacheModel("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_ball.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_artisan_melee/c_artisan_bat.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_molina/c_molina.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_retroactor/c_retroactor.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_smoking_snake/c_smoking_snake.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_tecnine/c_tecNine.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_tropic_bottle/c_tropic_bottle_exploded.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_tropic_launcher/c_tropic_launcher.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_tropic_launcher/w_cuban_rocket.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/c_models/c_tropic_revolver/c_tropic_revolver.mdl", true);
    PrecacheModel("models/weapons/tropic_crisis/retroactor/medic.mdl", true);

    PrecacheSound("tropic_crisis/weapons/retroactor/uber_ready.wav", true);
    PrecacheSound("tropic_crisis/weapons/retroactor/uber1.mp3", true);
    PrecacheSound("tropic_crisis/weapons/retroactor/uber2.mp3", true);
}

public void OnClientPutInServer(int client) {
    UberSound_OnClientPutInServer(client);
    StickBomb_OnClientPutInServer(client);
}

public void OnClientDisconnect(int client) {
    Model_OnClientDisconnect(client);
    UberSound_OnClientDisconnect(client);
    StickBomb_OnClientDisconnect(client);
}

public void OnEntityCreated(int entity, const char[] classname) {
    if(StrEqual(classname, "tf_projectile_rocket")) {
        Rocket_OnRocketProjectileCreated(entity);
    } else if(StrEqual(classname, "tf_projectile_stun_ball")) {
        Ball_OnBallProjectileCreated(entity);
    }
}
