void Ball_OnBallProjectileCreated(int ball) {
    SDKHook(ball, SDKHook_SpawnPost, OnBallProjectileSpawnPost);
}

static void OnBallProjectileSpawnPost(int ball) {
    if(!IsValidEntity(ball)) {
        return;
    }

    int owner = GetEntPropEnt(ball, Prop_Send, "m_hOwnerEntity");
    if(!IsValidEntity(owner)) {
        return;
    }

    int weapon = GetPlayerWeaponSlot(owner, 2);
    if(!IsValidEntity(weapon)) {
        return;
    }

    char classname[64];
    GetEntityClassname(weapon, classname, sizeof(classname));

    char modelPath[PLATFORM_MAX_PATH];
    TF2CustAttr_GetString(weapon, "ball projectile model override", modelPath, sizeof(modelPath));
    if(modelPath[0] == '\0') {
        return;
    }

    int modelIndex = PrecacheModel(modelPath);

    for(int i = 0; i < 4; i++) {
        SetEntProp(ball, Prop_Send, "m_nModelIndexOverrides", modelIndex, _, i);
    }
}