static bool g_HasCustomModel[MAXPLAYERS + 1];

void Model_Init() {
    HookEvent("post_inventory_application", Event_PostInventoryApplication);
}

void Model_OnClientDisconnect(int client) {
    g_HasCustomModel[client] = false;
}

static Action Event_PostInventoryApplication(Event event, const char[] name, bool dontBroadcast) {
    int client = GetClientOfUserId(event.GetInt("userid"));
    if(client < 1 || client > MaxClients) {
        return Plugin_Continue;
    }

    UpdateModel(client);

    return Plugin_Continue;
}

static void UpdateModel(int client) {
    char model[PLATFORM_MAX_PATH];
    if(!GetCustomModelFromClientWeapons(client, model, sizeof(model))) {
        if(g_HasCustomModel[client]) {
            RemoveCustomModel(client);
            g_HasCustomModel[client] = false;
        }
        return;
    }

    SetCustomModel(client, model);
    g_HasCustomModel[client] = true;
}

static bool GetCustomModelFromClientWeapons(int client, char[] returnedModel, int maxLength) {
    for(int slot = TFWeaponSlot_Primary; slot <= TFWeaponSlot_Melee; slot++) {
        int weapon = GetPlayerWeaponSlot(client, slot);
        if(weapon == -1) {
            continue;
        }

        TF2CustAttr_GetString(weapon, "custom playermodel", returnedModel, maxLength);
        if(returnedModel[0] != '\0') {
            return true;
        }
    }

    return false;
}

static void SetCustomModel(int client, char[] modelPath) {
    PrecacheModel(modelPath);
    SetVariantString(modelPath);
    AcceptEntityInput(client, "SetCustomModelWithClassAnimations");
}

static void RemoveCustomModel(int client) {
    SetVariantString("");
    AcceptEntityInput(client, "SetCustomModel");
}
